<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Sliders.aspx.cs" Inherits="Sliders" %>

<%@ register assembly="Telerik.Web.UI" namespace="Telerik.Web.UI" tagprefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
        <asp:scriptmanager id="ScriptManager1" runat="server">
        </asp:scriptmanager>
        <telerik:radslider id="RadSlider1" runat="server" onclientslide="setOtherSliders"/>
        <asp:checkbox id="CheckBox1" runat="server"/>
        <telerik:radslider id="RadSlider2" runat="server" onclientslide="setOtherSliders"/>
        <asp:checkbox id="CheckBox2" runat="server"/>
        <telerik:radslider id="RadSlider3" runat="server" onclientslide="setOtherSliders"/>
        <asp:checkbox id="CheckBox3" runat="server"/>
        <telerik:radslider id="RadSlider4" runat="server" onclientslide="setOtherSliders"/>
        <asp:checkbox id="CheckBox4" runat="server"/>
        <script type="text/javascript">
        var checkBoxes;    
        var sliders;  
        
        //Initializes the arrays containing the sliders and the checkboxes 
        //and sets them initial values             
        Sys.Application.add_load(function() 
        {
            sliders = [
                $find('<%= RadSlider1.ClientID%>'),
                $find('<%= RadSlider2.ClientID%>'),
                $find('<%= RadSlider3.ClientID%>'),
                $find('<%= RadSlider4.ClientID%>')];
                
            checkBoxes = [
                document.getElementById('<%=CheckBox1.ClientID %>'),
                document.getElementById('<%=CheckBox2.ClientID %>'),
                document.getElementById('<%=CheckBox3.ClientID %>'),
                document.getElementById('<%=CheckBox4.ClientID %>')];
            
            for (var i=0; i<checkBoxes.length; i++)
            {   
                sliders[i].set_value(25);
                sliders[i].checkBox = checkBoxes[i];
            }
         }); 
         
        function getUncheckedBoxesCount()
        {
            var count = 0;
            for(var i = 0; i < checkBoxes.length; i++)
            {
                if(!checkBoxes[i].checked)
                {
                    count++;   
                }
            }
            return count;
        }
         
        function validateCheckBoxes(slider)
        {
            if(slider.checkBox.checked)
            {
                alert("If you want to slide this slider you should uncheck the corresponding checkbox!");
                return false;
            } 
            else if(getUncheckedBoxesCount() < 2)
            {
                alert("To accomplish sliding you need to have at least two unchecked boxes!");
                slider.checkBox.checked = true;
                return false;
            }
            return true;
        }
        
        function setOtherSliders(slider)
        {
            var remainder = 100;
            for(var i = 0; i < sliders.length; i++)
            {
                //The remaining value which has to be shared among the other sliders 
                remainder -= sliders[i].get_value();
            }
            //The value with which the current value of the other sliders will be increased
            var delta = remainder/(getUncheckedBoxesCount() - 1);
            
            for(var i = 0; i < checkBoxes.length; i++)
            {
                if(!checkBoxes[i].checked && sliders[i] != slider)
                {
                    //Sets the new value to each of the other sliders
                    sliders[i].set_value(sliders[i].get_value() + delta);
                }
            }
        }           
        
        //RadSlider does not suppor events for accomlishing this functionality, therefore 
        //we override some of its javascript functions to provide the needed functionality 
        Telerik.Web.UI.RadSlider.prototype._baseStartDragDrop = Telerik.Web.UI.RadSlider.prototype.startDragDrop;
        Telerik.Web.UI.RadSlider.prototype.startDragDrop = function(dragVisual)
        {
            if(!validateCheckBoxes(this))
            {
                return false;
            }            
            this._baseStartDragDrop(dragVisual);
        }
        
        Telerik.Web.UI.RadSlider.prototype._baseOnTrackMouseDown = Telerik.Web.UI.RadSlider.prototype._onTrackMouseDown;
        Telerik.Web.UI.RadSlider.prototype._onTrackMouseDown = function()
        {
            return false;
        }
        
        Telerik.Web.UI.RadSlider.prototype._baseOnMouseWheel = Telerik.Web.UI.RadSlider.prototype._onMouseWheel;
        Telerik.Web.UI.RadSlider.prototype._onMouseWheel = function()
        {
            return false;
        }

        Telerik.Web.UI.RadSlider.prototype._baseDoSmallStep = Telerik.Web.UI.RadSlider.prototype._doSmallStep;
        Telerik.Web.UI.RadSlider.prototype._doSmallStep = function(increase)
        {               
            if(!validateCheckBoxes(this))
            {
                return false;
            }
            this._baseDoSmallStep(increase);      
            setOtherSliders(this);
        }
        </script>
    </form>
</body>
</html>
